'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clearInstanceIdCounters = exports.resetInstanceIdCounters = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

exports.default = traceLifecycle;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _constants = require('./constants');

var constants = _interopRequireWildcard(_constants);

var _actionCreators = require('./redux/actionCreators');

var ActionCreators = _interopRequireWildcard(_actionCreators);

var _util = require('./util');

var _LifecyclePanel = require('./components/LifecyclePanel');

var _LifecyclePanel2 = _interopRequireDefault(_LifecyclePanel);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var instanceIdCounters = {};

var resetInstanceIdCounters = exports.resetInstanceIdCounters = function resetInstanceIdCounters() {
  Object.keys(instanceIdCounters).forEach(function (k) {
    return delete instanceIdCounters[k];
  });
};

var clearInstanceIdCounters = exports.clearInstanceIdCounters = (0, _util.withDeprecationWarning)(constants.DEPRECATED_CLEAR_COUNTERS, resetInstanceIdCounters);

var mkInstanceId = function mkInstanceId(componentName) {
  if (!Object.prototype.hasOwnProperty.call(instanceIdCounters, componentName)) {
    instanceIdCounters[componentName] = 0;
  }
  instanceIdCounters[componentName] += 1;
  return instanceIdCounters[componentName];
};

function traceLifecycle(ComponentToTrace) {
  var componentToTraceName = ComponentToTrace.displayName || ComponentToTrace.name || 'Component';

  var superMethods = Object.getOwnPropertyNames(ComponentToTrace.prototype).concat(ComponentToTrace.getDerivedStateFromProps ? [_constants.MGetDerivedState] : []);

  var isLegacy = // component is legacy if it includes one of the legacy methods and no new methods.
  superMethods.some(function (member) {
    return constants.lifecycleMethodNamesLegacyOnly.includes(member);
  }) && superMethods.every(function (member) {
    return !constants.lifecycleMethodNamesNewOnly.includes(member);
  });

  var implementedMethods = [].concat(_toConsumableArray(superMethods), [_constants.MSetState]);

  var TracedComponent = function (_ComponentToTrace) {
    _inherits(TracedComponent, _ComponentToTrace);

    function TracedComponent(props, context) {
      _classCallCheck(this, TracedComponent);

      props.trace(_constants.MConstructor);

      var _this = _possibleConstructorReturn(this, (TracedComponent.__proto__ || Object.getPrototypeOf(TracedComponent)).call(this, props, context, props.trace));

      _this.LifecyclePanel = (0, _util.withDeprecationWarning)(constants.DEPRECATED_THIS_LIFECYCLE_PANEL, props.LifecyclePanel);
      _this.trace = (0, _util.withDeprecationWarning)(constants.DEPRECATED_THIS_TRACE, props.trace);
      return _this;
    }

    _createClass(TracedComponent, [{
      key: 'componentWillMount',
      value: function componentWillMount() {
        this.props.trace(_constants.MWillMount);
        if (_get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'componentWillMount', this)) {
          _get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'componentWillMount', this).call(this);
        }
      }
    }, {
      key: 'componentDidMount',
      value: function componentDidMount() {
        this.props.trace(_constants.MDidMount);
        if (_get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'componentDidMount', this)) {
          _get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'componentDidMount', this).call(this);
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.props.trace(_constants.MWillUnmount);
        if (_get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'componentWillUnmount', this)) {
          _get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'componentWillUnmount', this).call(this);
        }
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps() {
        this.props.trace(_constants.MWillReceiveProps);
        if (_get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'componentWillReceiveProps', this)) {
          var _get2;

          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          (_get2 = _get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'componentWillReceiveProps', this)).call.apply(_get2, [this].concat(args));
        }
      }
    }, {
      key: 'shouldComponentUpdate',
      value: function shouldComponentUpdate() {
        var _get3;

        this.props.trace(_constants.MShouldUpdate);

        for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }

        return _get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'shouldComponentUpdate', this) ? (_get3 = _get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'shouldComponentUpdate', this)).call.apply(_get3, [this].concat(args)) : true;
      }
    }, {
      key: 'componentWillUpdate',
      value: function componentWillUpdate() {
        this.props.trace(_constants.MWillUpdate);
        if (_get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'componentWillUpdate', this)) {
          var _get4;

          for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
            args[_key3] = arguments[_key3];
          }

          (_get4 = _get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'componentWillUpdate', this)).call.apply(_get4, [this].concat(args));
        }
      }
    }, {
      key: 'render',
      value: function render() {
        if (_get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'render', this)) {
          this.props.trace(_constants.MRender);
          return _get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'render', this).call(this);
        }
        return undefined; // no super.render, this will trigger a React error
      }
    }, {
      key: 'getSnapshotBeforeUpdate',
      value: function getSnapshotBeforeUpdate() {
        var _get5;

        this.props.trace(_constants.MGetSnapshot);

        for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
          args[_key4] = arguments[_key4];
        }

        return _get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'getSnapshotBeforeUpdate', this) ? (_get5 = _get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'getSnapshotBeforeUpdate', this)).call.apply(_get5, [this].concat(args)) : null;
      }
    }, {
      key: 'componentDidUpdate',
      value: function componentDidUpdate() {
        this.props.trace(_constants.MDidUpdate);
        if (_get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'componentDidUpdate', this)) {
          var _get6;

          for (var _len5 = arguments.length, args = Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
            args[_key5] = arguments[_key5];
          }

          (_get6 = _get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'componentDidUpdate', this)).call.apply(_get6, [this].concat(args));
        }
      }
    }, {
      key: 'setState',
      value: function setState(updater, callback) {
        var _this2 = this;

        this.props.trace(_constants.MSetState);

        // Unlike the lifecycle methods we only trace the update function and callback
        // when they are actually defined.
        var tracingUpdater = typeof updater !== 'function' ? updater : function () {
          _this2.props.trace(_constants.MSetState + ':update fn');
          return updater.apply(undefined, arguments);
        };

        var tracingCallback = !callback ? undefined : function () {
          _this2.props.trace(_constants.MSetState + ':callback');
          callback.apply(undefined, arguments);
        };
        _get(TracedComponent.prototype.__proto__ || Object.getPrototypeOf(TracedComponent.prototype), 'setState', this).call(this, tracingUpdater, tracingCallback);
      }
    }], [{
      key: 'getDerivedStateFromProps',
      value: function getDerivedStateFromProps(nextProps, prevState) {
        nextProps.trace(_constants.MGetDerivedState);
        return ComponentToTrace.getDerivedStateFromProps ? ComponentToTrace.getDerivedStateFromProps(nextProps, prevState, nextProps.trace) : null;
      }
    }]);

    return TracedComponent;
  }(ComponentToTrace);

  TracedComponent.displayName = componentToTraceName;

  var TracingComponent = function (_Component) {
    _inherits(TracingComponent, _Component);

    function TracingComponent(props, context) {
      _classCallCheck(this, TracingComponent);

      var _this3 = _possibleConstructorReturn(this, (TracingComponent.__proto__ || Object.getPrototypeOf(TracingComponent)).call(this, props, context));

      var instanceId = mkInstanceId(ComponentToTrace.name);

      var WrappedLifecyclePanel = function WrappedLifecyclePanel() {
        return _react2.default.createElement(_LifecyclePanel2.default, {
          componentName: componentToTraceName,
          isLegacy: isLegacy,
          instanceId: instanceId,
          implementedMethods: implementedMethods
        });
      };
      _this3.LifecyclePanel = WrappedLifecyclePanel;

      _this3.trace = function (methodName) {
        _this3.context[constants.reduxStoreKey].dispatch(ActionCreators.trace(componentToTraceName, instanceId, methodName));
      };
      return _this3;
    }

    _createClass(TracingComponent, [{
      key: 'render',
      value: function render() {
        return _react2.default.createElement(TracedComponent, _extends({ LifecyclePanel: this.LifecyclePanel, trace: this.trace }, this.props));
      }

      // Get store directly from context, to prevent introducing extra `Connect` component.

    }]);

    return TracingComponent;
  }(_react.Component);

  // Removing the inappropriate methods is simpler than adding appropriate methods to prototype


  TracingComponent.contextTypes = _extends({}, ComponentToTrace.contextTypes, _defineProperty({}, constants.reduxStoreKey, _propTypes2.default.object));
  TracingComponent.displayName = 'traceLifecycle(' + componentToTraceName + ')';
  if (isLegacy) {
    delete TracedComponent.getDerivedStateFromProps;
    delete TracedComponent.prototype.getSnapshotBeforeUpdate;
  } else {
    delete TracedComponent.prototype.componentWillMount;
    delete TracedComponent.prototype.componentWillReceiveProps;
    delete TracedComponent.prototype.componentWillUpdate;
  }

  return TracingComponent;
}